#ifndef _LISTE_H
#define _LISTE_H

/* Topic: Documentation du module Liste
 * Module permettant l'utilisation d'une liste gnralise  tous les types.
 * 
 * Une liste doit toujours tre initialise avant l'utilisation de celle-ci.
 * Lorsque l'utilisateur n'en a plus besoin, il faut la dtruire par librer l'espace
 * allou par celle-ci.
 */

typedef void ElementListe;


typedef struct Liste_cellule_ {
        ElementListe* element;
        struct Liste_cellule_ * suivant;
        struct Liste_cellule_ * precedent;
        } Liste_cellule;
        
typedef struct Liste_ {
        Liste_cellule* premier;
        Liste_cellule* dernier;
        int            taille;
        Liste_cellule* derniere_cellule_lue;
        int            derniere_position;
               
        } Liste;
        
/*constructeur et destructeur*/
/**Function: listeInitialiser
 * Initialisation d'une liste
 *
 * Paramtres:
 * liste - liste devant tre initialise
 */
void listeInitialiser (Liste* liste);

/**Function: listeDetruire
 * Destruction de toute la liste  partir de son pointeur
 *
 * Paramtres
 * liste - liste devant tre dtruite
 */
void listeDetruire (Liste* liste);

/*modificateurs d'tats*/

/**Function: listeAjouter
 * Permet d'ajouter un pointeur vers un lment  une liste
 *
 * Paramtres
 * liste - la liste ou doit tre ajout l'lment
 * position - la position ou ajouter l'lment
 * element - le pointeur vers l'lment  ajouter
 *
 * Erreur:
 *  Dans le cas d'une limite mmoire, un message d'erreur sera affich sur la sortie stderr
 *  Dans le cas d'une tentative d'ajout hors borne, un message d'erreur est affich sur la sortie stderr
 */
void listeAjouter (Liste* liste, int position, ElementListe* element);

/**Function: listeRetirer
 * Permet de retirer un lment d'une liste
 *
 * Paramtres
 * liste - la liste ou doit tre retir l'lment
 * position - la position ou retirer l'lment
 *
 * Erreur:
 *  Dans le cas d'une tentative d'ajout hors borne, un message d'erreur est affich sur la sortie stderr
 */
void listeRetirer (Liste* liste, int position);

/**Function: listeAjouterFin
 * Permet d'ajouter un lment  la fin d'un fichier
 *
 * Paramtres
 * liste - la liste ou doit tre ajoutl'lment
 * element - l'lment  ajouter
 *
 * Erreur:
 *  Dans le cas d'un problme mmoire, un message d'erreur est affich sur la sortie stderr
 */
void listeAjouterFin(Liste* liste, ElementListe* element);

void listeEcrire(Liste* liste, int position, ElementListe* element);

/*accesseurs*/
/**Function: listeLire
 * Permet de recuperer un lment d'une liste
 *
 * Paramtre:
 * liste - la liste ou l'on doit lire l'lment
 * position - position de l'lment
 *
 * Retour: 
 * Un pointeur vers l'lment lu
 *
 * Erreur:
 *  Dans le cas d'une tentative d'criture hors borne, le pointeur NULL est retourn
 */
ElementListe* listeLire (Liste* liste, int position);

/**Function: listeTaille
 *  Dtermine la taille d'une liste
 * Paramtre:
 * liste - liste  dterminer la taille
 *
 * Retour:
 *  Le taille de la liste
 */
int listeTaille (Liste* liste);

int listeEstVide (Liste* liste);
//ElementListe* listeLire(Liste* liste, int position);
#endif
